=== debian/tests/control ===
Tests: rebuild
Depends: @builddeps@, fakeroot, binutils, linux-libc-dev [linux-any], gcc
Restrictions: allow-stderr
